/**
 * @module package/quiqqer/products/bin/controls/search/searchtypes/Bool
 * @author www.pcsg.de (Henning Leutz)
 *
 * Ein Ja / Nein Feld
 *
 * @require qui/QUI
 * @require qui/controls/Control
 * @require qui/controls/buttons/Select
 *
 * @event onChange
 *
 * @todo translation
 */
define('package/quiqqer/products/bin/controls/search/searchtypes/Bool', [

    'qui/QUI',
    'qui/controls/Control',
    'qui/controls/buttons/Select'

], function (QUI, QUIControl, QUISelect) {
    "use strict";

    return new Class({
        Extends: QUIControl,
        Type   : 'package/quiqqer/products/bin/controls/search/searchtypes/Bool',

        Binds: [
            '$onImport'
        ],

        initialize: function (options) {
            this.$Elm    = null;
            this.$Select = null;

            this.parent(options);
        },

        /**
         * Create the domnode element
         *
         * @return {HTMLDivElement}
         */
        create: function () {
            this.$Select = new QUISelect();
            this.$Elm    = this.$Select.create();
            this.$Elm.addClass('quiqqer-products-searchtype-bool');

            this.$Select.appendChild('Ja', 1);
            this.$Select.appendChild('Nein', 0);

            this.$Select.addEvent('change', function () {
                this.fireEvent('change', [this]);
            }.bind(this));

            return this.$Elm;
        },

        /**
         * Reset the field
         */
        reset: function () {
            this.$Select.setValue(0);
        },

        /**
         * set the search data
         *
         * @param {object|array} data
         */
        setSearchData: function (data) {

        },

        /**
         * Set the input select value
         * @param value
         */
        setSearchValue: function (value) {
            this.setAttribute('value', value);

        },

        /**
         * Return the search value
         *
         * @returns {String|Boolean}
         */
        getSearchValue: function () {
            return this.$Select.getValue();
        }
    });
});
